'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactVirtualized = require('react-virtualized');

var _Title = require('./renderers/Title.component');

var _Title2 = _interopRequireDefault(_Title);

var _VirtualizedList = require('./VirtualizedList.scss');

var _VirtualizedList2 = _interopRequireDefault(_VirtualizedList);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Create new Columns with component classnames from children
 */
function toColumns(children) {
	return _react2.default.Children.toArray(children).map(function (column) {
		var colProps = _extends({}, column.props, {
			headerClassName: (0, _classnames2.default)(column.props.headerClassName, _VirtualizedList2.default.header),
			className: (0, _classnames2.default)(column.props.className, _VirtualizedList2.default.cell)
		});
		return _react2.default.createElement(_reactVirtualized.Column, colProps);
	});
}

function VirtualizedList(props) {
	var collection = props.collection,
	    children = props.children;

	return _react2.default.createElement(
		_reactVirtualized.AutoSizer,
		null,
		function (_ref) {
			var height = _ref.height,
			    width = _ref.width;
			return _react2.default.createElement(
				_reactVirtualized.Table,
				{
					className: _VirtualizedList2.default['tc-list'],
					gridClassName: _VirtualizedList2.default.grid,
					headerHeight: 35,
					height: height,
					rowClassName: _VirtualizedList2.default.row,
					rowCount: collection.length,
					rowGetter: function rowGetter(_ref2) {
						var index = _ref2.index;
						return collection[index];
					},
					rowHeight: 50,
					width: width
				},
				toColumns(children)
			);
		}
	);
}
VirtualizedList.propTypes = {
	collection: _react.PropTypes.arrayOf(_react.PropTypes.object),
	children: _react.PropTypes.arrayOf(_react.PropTypes.element)
};

VirtualizedList.Column = _reactVirtualized.Column;
VirtualizedList.TitleRenderer = {
	cellRenderer: _Title2.default,
	className: 'tc-list-title-cell'
};

exports.default = VirtualizedList;